-- you better make better collision physics for sliding collisions
-- resisting collisions on top of bodys doesnt prevent bodys from hooking each other << works only on bodys with lesser ID
-- put animation updating in world update?
-- does air friction work less on character? because it works less on more mass
-- after a little walk character twists his hands - done
--will need to reset animations
--avoid expensive square root
--maybe make a simplification - if body is on top of body that is on a surface and have dz that is negative, then set dz to 0 - or not
--change something in world:update for spheres - done
--radius for boxes is radius of their bounding sphere
--/(2^0.5) <- change it to proectionCoef - done!
--make aoe work not only for box but for sphere too(or not?) - done
--animation update be in separate cycle?
--make some proper input resolving
--actions could change mid processing so you need to stabilize that

--projectile - toExplode


--body : x1, y1, z1, width, thickness, height, dx, dy, dz, mass
--body shapes: sphere and box
--body types: character, object, hitbox, projectile, AoE
    require("events")
    distanceCoef = 16
    Animation = {timer = 0, type = "loop", totalDuration = 0, static = false}
    Body = {dx = 0, dy = 0, dz = 0, z1 = 0, onSurface = false, radius = 0, width = 0, thickness = 0, height = 0, mass = 1.0, toDestroy = false, physicless = false} --weird that tables for debug are working wrong - not
    --physicless here means that no gravity or drag will affect body
	Character = setmetatable({type = "unknown", action = {"walk", 0, 0}, surfaceTimer = 0.1, jumped = true, bodyShape = "box", bodyType = "character", dragCoef = 0.82, dashAcceleration = 120}, {__index = Body})
	--projectile: ownership(?), radius, acceleration, startingSpeed
	Projectile = setmetatable({acceleration = 0, bodyShape = "sphere", bodyType = "projectile", dragCoef = 0.47, damage = 0, lifetime = 0}, {__index = Body})	
	--timeToLive = nil means that it can fly without timer
	AoE = setmetatable({acceleration = 0, bodyShape = "sphere", bodyType = "aoe", dragCoef = 0.47, damage = 0, physicless = true, lifetime = 0}, {__index = Body})
    --AoE is area of effect
    World = {gravityX = 0, gravityY = 0, gravityZ = 9.81*distanceCoef}
	--explodey projectile: explosion
	ImpactExplosionProjectile = setmetatable({ startingSpeed = 250},  {__index = Projectile})
	Explosion = setmetatable({ maxForce = 1 }, {__index = AoE})
--Enemy and stuff = {}
-- after some time coordinates may lose precision, so you need to store width, depth and height? - done
    Phrase = { }
	Reply = { }
	events = {{caused = false} --[[demons = {}, illusionist = {}, ninjas = {}, cat = {},--]]}

--these are default choosings
function Phrase:chooseReply()
    if lmb_pressed_once[3] == true then
	    debwog[1] = 1
	    if replyBounds[1] < lmb_pressed_once[1] and lmb_pressed_once[1] < ( replyBounds[1] + replyBounds.width ) then
		    debwog[2] = 1
		    local I = 1
	        while self[I] ~= nil do
			    if ( replyBounds[2] + replyBounds.gapY * (I - 1) ) < lmb_pressed_once[2] and lmb_pressed_once[2] < ( replyBounds[2] + replyBounds.height + replyBounds.gapY * (I - 1) ) then
				    debwog[3] = 1
					--lmb_pressed_once[3] = false - not needed
					return I
				end
			    I = I + 1
			end
		end
	end
	return 0
end
function Reply:choosePhrase()
    return 1
end
function ImpactExplosionProjectile:sphereLogic( box, I, J, world )
    if box.bodyType == "character" and self.ownership ~= J and not self.toDestroy then
	    deboog[2] = "GRAH"
		box.curHP = box.curHP - self.damage
		local VX = self.dx - box.dx
		local VY = self.dy - box.dy
		local VZ = self.dz - box.dz
		local m1plusm2 = self.mass + box.mass
		local m1minusm2 = self.mass - box.mass
		local m1multby2 = self.mass * 2
		self.dx = box.dx + 1 * VX * (m1minusm2 / m1plusm2)
		box.dx = box.dx + 1 * VX * (m1multby2 / m1plusm2)
		self.dy = box.dy + 1 * VY * (m1minusm2 / m1plusm2)
		box.dy = box.dy + 1 * VY * (m1multby2 / m1plusm2)								
		self.dz = box.dz + 1 * VZ * (m1minusm2 / m1plusm2)
		box.dz = box.dz + 1 * VZ * (m1multby2 / m1plusm2)		
		local aoe = deepcopy(self.explosion)
		aoe.x1 = self.x1
		aoe.y1 = self.y1
		aoe.z1 = self.z1
		--self[1][I].dx = self[1][I].dx + math.cos(angleXY) * math.sin(angleZX) / self[1][I].mass) * dt		
		aoe.ownership = I
		--deboog[2] = #
		table.insert(world[1], aoe)
		self.toDestroy = true
	end
end

function Explosion:sphereLogic( body, I, J, world )
    --distance * maxForce/radius + maxForce
    --if you make spheres get pushed, then make aoe dont
	local distanceX = (body.x1 + body.width/2) - self.x1  
	local distanceY = (body.y1 + body.thickness/2) - self.y1 
	local distanceZ = (body.z1 + body.height/2) - self.z1 
    local distanceXYZ = (distanceX^2 + distanceY^2 + distanceZ^2)^0.5
	local forceMagnitude = distanceXYZ * self.maxForce/self.radius + self.maxForce
	--local angleXY = 0--math.atan2(self[1][I].dy,self[1][I].dx)
	--local angleYZ = 0--math.atan2(self[1][I].dz,self[1][I].dy)
	--local angleZX = 0--math.atan2(self[1][I].dx,self[1][I].dz)
	local angleXY = math.atan2(distanceY,distanceX)
	local angleYZ = math.atan2(distanceZ,distanceY)
	local angleZX = math.atan2(distanceX,distanceZ)
	--angleXY = angleXY + math.rad(180)
	--angleYZ = angleYZ + math.rad(180)
	--angleZX = angleZX + math.rad(180)
	local dxCoef, dyCoef, dzCoef = 1,1,1
	if math.cos(angleXY) < 0 and math.sin(angleZX) < 0 then
	    dxCoef = -1
	end
	if math.cos(angleYZ) < 0 and math.sin(angleXY) < 0 then
	    dyCoef = -1
	end
	if math.cos(angleZX) < 0 and math.sin(angleYZ) < 0 then
	    dzCoef = -1
	end
	body.dx = body.dx + dxCoef * (forceMagnitude * math.cos(angleXY) * math.sin(angleZX) / body.mass)
	body.dy = body.dy + dyCoef * (forceMagnitude * math.cos(angleYZ) * math.sin(angleXY) / body.mass)
	body.dz = body.dz + dzCoef * (forceMagnitude * math.cos(angleZX) * math.sin(angleYZ) / body.mass)
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function initialize(variable, value)
    if variable == nil then
        variable = deepcopy(value)
	end
end
function Animation:update(dt)
    if self.static then
	    return true
	end
    self.timer = self.timer + dt
	local I = 1
	if self.totalDuration == 0 then
	    while I <= #(self[2]) do
		    self.totalDuration = self.totalDuration + self[2][I]
			I = I + 1
		end
	end
	if self.type == "loop"  and self.timer > self.totalDuration then
	    self.timer = 0
	end
	--if self.type
	I = 1
	local T = self.timer
	while I <= #(self[2]) do 
	    T = T - self[2][I]
	    if T <= 0 then
	        self.currentImg = self[1][I]
			break
		end
		I = I + 1
	end
	return true
end
function Character:changeCurrentAnim( animation )
    if self.currentAnim ~= animation then
	    if not self.currentAnim.static then
	        self.currentAnim.timer = 0
		end
		self.currentAnim = animation
		self.currentAnim:update(0)
	end
	
end
function Character:setWalkAnimation(dt)
    if self.action[3] == 0 then
	    if self.currentAnim == self.walk_up then
		    self:changeCurrentAnim( self.idle_back )
		elseif self.currentAnim == self.walk_left then
			self:changeCurrentAnim( self.idle_left )
		elseif self.currentAnim == self.walk_down then
			self:changeCurrentAnim( self.idle_front )
		elseif self.currentAnim == self.walk_right then
			self:changeCurrentAnim( self.idle_right )
		end
	else
        if -0.477658 - math.rad(90) <= self.action[2] and self.action[2] <= -1.09314 then
		    self:changeCurrentAnim( self.walk_up )
		elseif 0.477658 + math.rad(90) <= self.action[2] or self.action[2] <= -0.477658 - math.rad(90) then
			self:changeCurrentAnim( self.walk_left )
		elseif 1.09314 <= self.action[2] and self.action[2] <= 0.477658 + math.rad(90) then
			self:changeCurrentAnim( self.walk_down )
		else
			self:changeCurrentAnim( self.walk_right )
		end
				
    end

end
function Character:drawCharacter()
--[[
    if self.animation_state == "idle_back" then
	    love.graphics.draw( self.idle_back, self.x1 + (self.width - self.idle_back:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef))-- self.idle_back:getHeight() )
	elseif self.animation_state == "idle_left" then
	    love.graphics.draw( self.idle_side, self.x1 + self.width - (self.width - self.idle_side:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef), 0, -1, 1 )
	elseif self.animation_state == "idle_front" then
	    love.graphics.draw( self.idle_front, self.x1 + (self.width - self.idle_front:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef) )
	elseif self.animation_state == "idle_right" then
	    love.graphics.draw( self.idle_side, self.x1 + (self.width - self.idle_side:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef) )
	elseif self.animation_state == "walk_up" then
	    love.graphics.draw( self.walk_up.currentImg, self.x1 + (self.width - self.walk_up.currentImg:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef) )
	elseif self.animation_state == "walk_left" then
	    love.graphics.draw( self.walk_side.currentImg, self.x1 + self.width - (self.width - self.walk_side.currentImg:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef), 0, -1, 1 )
	elseif self.animation_state == "walk_down" then
	    love.graphics.draw( self.walk_down.currentImg, self.x1 + (self.width - self.walk_down.currentImg:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef))
	elseif self.animation_state == "walk_right" then
	    love.graphics.draw( self.walk_side.currentImg, self.x1 + (self.width - self.walk_side.currentImg:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef))
	elseif self.animation_state == "jumping" then
	    love.graphics.draw( self.idle_front, self.x1 + (self.width - self.idle_front:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef) )
    end
	return true
--]]
    if not self.currentAnim.currentImg.flipX then
	    love.graphics.draw( self.currentAnim.currentImg.image, self.x1 + (self.width - self.currentAnim.currentImg.image:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef))-- self.idle_back:getHeight() )
    else
	    love.graphics.draw( self.currentAnim.currentImg.image, self.x1 + self.width - (self.width - self.currentAnim.currentImg.image:getWidth())/2, (self.y1 + self.thickness/2 - self.z1 - self.height)/(proectionCoef), 0, -1, 1 )
	end
end
function Projectile:drawProjectile()
--add something for dy probably
    --if ownership is of player, then
	if self.ownership == 1 then
        love.graphics.setColor(255,255,255,100)
	else
	--100 - min, 255 - max
	    
	    love.graphics.setColor(255,255,255,math.max(255 - math.abs(self.z1 - gameWorld[1][1].z1)*2, 100))
    end
	--else calculate transparency
    if self.sprite ~= nil then
        love.graphics.draw( self.sprite.currentImg, self.x1 - self.sprite.currentImg:getWidth()/2, (self.y1 + self.radius - self.z1 - self.radius * 2)/(proectionCoef)  )
	end
	love.graphics.setColor(255,255,255)
end
	
function Character:walk( dt )
    if self.onSurface then
	-- just get the damn sign of sin and cos
	--do something if cosangle or sinangle == 0(right-if you moving faster than walk speed - then reduce speed)
	    --[[local--]] cosangle, sinangle = math.cos(self.action[2]), math.sin(self.action[2])
		if cosangle * self.action[3]  ~= 0 then
		    local cos_sign
		    if cosangle > 0 then
		        cos_sign = 1
		    else
			    cos_sign = -1
			end
			if cos_sign == -1 then
	            if self.dx > self.movementSpeed * cosangle * self.action[3] then
		            self.dx = math.max(self.dx + ( self.movementAcceleration * cos_sign * dt * self.action[3] ),self.movementSpeed * cosangle * self.action[3])
		        end
		        
		        if self.dx < ( self.movementSpeed * cosangle * self.action[3] ) then
		            self.dx = math.min(self.dx - ( self.movementAcceleration * cos_sign * dt * self.action[3] ), self.movementSpeed * cosangle * self.action[3])
		        end
			elseif cos_sign == 1 then
			    if self.dx < self.movementSpeed * cosangle * self.action[3] then
		            self.dx = math.min(self.dx + ( self.movementAcceleration * cos_sign * dt * self.action[3] ),self.movementSpeed * cosangle * self.action[3])
		        end
		        
		        if self.dx > ( self.movementSpeed * cosangle * self.action[3] ) then
		            self.dx = math.max(self.dx - ( self.movementAcceleration * cos_sign * dt * self.action[3] ), self.movementSpeed * cosangle * self.action[3])
		        end
			end
		else
		    if self.dx < 0 then
		        self.dx = math.min(self.dx + ( self.movementAcceleration * dt ),0)	        
		    end
		    
		    if self.dx > 0 then
		        self.dx = math.max(self.dx - ( self.movementAcceleration * dt ),0)	        
		    end
		end
		if sinangle * self.action[3] ~= 0 then
		    local sin_sign
            if sinangle > 0 then
		        sin_sign = 1
		    else
			    sin_sign = -1
			end
			if sin_sign == -1 then
	            if self.dy > self.movementSpeed * sinangle * self.action[3] then
		            self.dy = math.max(self.dy + ( self.movementAcceleration * sin_sign * dt * self.action[3] ), self.movementSpeed * sinangle * self.action[3])
		        end
		        
		        if self.dy < ( self.movementSpeed * sinangle * self.action[3] ) then
		            self.dy = math.min(self.dy - ( self.movementAcceleration * sin_sign * dt * self.action[3] ), self.movementSpeed * sinangle * self.action[3])
		        end
			elseif sin_sign == 1 then
			    if self.dy < self.movementSpeed * sinangle * self.action[3] then
		            self.dy = math.min(self.dy + ( self.movementAcceleration * sin_sign * dt * self.action[3] ), self.movementSpeed * sinangle * self.action[3])
		        end
		        
		        if self.dy > ( self.movementSpeed * sinangle * self.action[3] ) then
		            self.dy = math.max(self.dy - ( self.movementAcceleration * sin_sign * dt * self.action[3] ), self.movementSpeed * sinangle * self.action[3])
		        end
			end
	    else
		    if self.dy < 0 then
		        self.dy = math.min(self.dy + ( self.movementAcceleration * dt ),0)     
		    end
		    
		    if self.dy > 0 then
		        self.dy = math.max(self.dy - ( self.movementAcceleration * dt ),0)		        
		    end
		end
    end
end

function Character:dash( )
    local cosangle, sinangle = math.cos(self.action[2]), math.sin(self.action[2])	
	self.dx = self.dx + ( self.dashAcceleration * cosangle * self.action[3] )
	self.dy = self.dy + ( self.dashAcceleration * sinangle * self.action[3] )

end

function World:collisionOfSphereAndBox( I, J )
    local sqDist = 0.0
    if self[1][I].x1 < self[1][J].x1 then 
	    sqDist = sqDist + (self[1][J].x1 - self[1][I].x1)^2
    end
    if self[1][I].x1 > self[1][J].x1 + self[1][J].width then
    	sqDist = sqDist + (self[1][J].x1 + self[1][J].width - self[1][I].x1)^2
    end
    if self[1][I].y1 < self[1][J].y1 then
    	sqDist = sqDist + (self[1][J].y1 - self[1][I].y1)^2
    end
    if self[1][I].y1 > self[1][J].y1 + self[1][J].thickness then
    	sqDist = sqDist + (self[1][J].y1 + self[1][J].thickness - self[1][I].y1)^2
    end
    if self[1][I].z1 < self[1][J].z1 then
    	sqDist = sqDist + (self[1][J].z1 - self[1][I].z1)^2
    end
    if self[1][I].z1 > self[1][J].z1 + self[1][J].height then
    	sqDist = sqDist + (self[1][J].z1 + self[1][J].height - self[1][I].z1)^2
    end
    if sqDist <= self[1][I].radius^2 then
	    --probably make functions for different types of projectiles?
		--also not all boxes are characters to take health from - for example hitboxes - or maybe make hitboxes destroy projectiles?
		self[1][I]:sphereLogic( self[1][J], I, J, self )
		
	end
end

function World:collisionOfAoEandProjectile( I, J )
    local sqDist = ((self[1][J].x1 - self[1][I].x1)^2 + (self[1][J].y1 - self[1][I].y1)^2 + (self[1][J].z1 - self[1][I].z1)^2)
    if sqDist <= (self[1][I].radius + self[1][J].radius)^2 then
	    self[1][I]:sphereLogic( self[1][J], I, J, self )
    end

end

function World:AI(dt)
    --[[local--]]-- player_dash_trigger
	local player_dash_trigger_time = 0.3
    --player_dash_cooldown_timer
	local player_dash_cooldown_time = 0.6
	local player_jump_cooldown_time = 0.5
	if player_dash_trigger == nil then
	  player_dash_trigger = {}
	  player_dash_trigger.timer = 0
	end
	if player_dash_trigger.timer <= 0 then
	    player_dash_trigger.almost = false
	end
	if player_dash_cooldown_timer == nil then
	  player_dash_cooldown_timer = 0
	end
	--initialize(player_dash_cooldown_timer, 0)
	if player_jump_cooldown_timer == nil then
	  player_jump_cooldown_timer = 0
	end
	if player_dash_cooldown_timer > 0 then
	  player_dash_cooldown_timer = player_dash_cooldown_timer - dt
	end
	if player_jump_cooldown_timer > 0 then
	  player_jump_cooldown_timer = player_jump_cooldown_timer - dt
	end
    if w_pressed and a_pressed then
	    player_dash_trigger.value = math.rad(225)---1.01722 * 2
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value , 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_left ) 		
	elseif s_pressed and a_pressed then
	    player_dash_trigger.value = math.rad(135)--1.01722 * 2
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_left ) 
	elseif s_pressed and d_pressed then
	    player_dash_trigger.value = math.rad(45)--0.553574 * 2
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_right ) 
	elseif w_pressed and d_pressed then
	    player_dash_trigger.value = math.rad(315)---0.553574 * 2
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_right ) 
    elseif w_pressed then
	    player_dash_trigger.value = math.rad(270)
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_up )
	elseif a_pressed then
	    player_dash_trigger.value = math.rad(180)
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_left ) 
	elseif s_pressed then
	    player_dash_trigger.value = math.rad(90)
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_down ) 
	elseif d_pressed then
	    player_dash_trigger.value = 0
		player_dash_trigger.timer = player_dash_trigger_time
	    gameWorld[1][1].action = {"walk", player_dash_trigger.value, 1}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].walk_right ) 
    elseif player_dash_trigger.timer > 0 and player_dash_trigger.prevvalue ~= nil then 
        player_dash_trigger.timer = player_dash_trigger.timer - dt
        if not w_pressed and not a_pressed then
	        if player_dash_trigger.prevvalue == math.rad(225) then---1.01722 * 2 then
			    player_dash_trigger.almost = true
            end			
        end			
	    if not s_pressed and not a_pressed then
	        if player_dash_trigger.prevvalue == math.rad(135) then--1.01722 * 2 then
			    player_dash_trigger.almost = true
            end	
        end			
	    if not s_pressed and not d_pressed then
	        if player_dash_trigger.prevvalue == math.rad(45) then--0.553574 * 2 then
			    player_dash_trigger.almost = true
            end	
        end			
	    if not w_pressed and not d_pressed then
	        if player_dash_trigger.prevvalue == math.rad(315) then---0.553574 * 2 then
			    player_dash_trigger.almost = true
            end	
        end	        
        if not w_pressed then
	        if player_dash_trigger.prevvalue == math.rad(270) then
			    player_dash_trigger.almost = true
            end	
        end			
	    if not a_pressed then
	        if player_dash_trigger.prevvalue == math.rad(180) then
			    player_dash_trigger.almost = true
            end	
        end			
	    if not s_pressed then
	        if player_dash_trigger.prevvalue == math.rad(90) then
			    player_dash_trigger.almost = true
            end	
        end			
	    if not d_pressed then
	        if player_dash_trigger.prevvalue == 0 then
			    player_dash_trigger.almost = true
            end	
	    end		
    end	
    if player_dash_trigger.almost and player_dash_trigger.value ~= nil and player_dash_cooldown_timer <= 0 then
	    if player_dash_trigger.prevvalue ~= nil and player_dash_trigger.value == player_dash_trigger.prevvalue then
		    gameWorld[1][1].action = {"dash", player_dash_trigger.value, math.random()*0.8 + 0.2}--random makes dash imprecise
			player_dash_cooldown_timer = player_dash_cooldown_time
		end	
        player_dash_trigger.almost = false
        player_dash_trigger.timer = 0		
	end
	if player_dash_trigger.value ~= nil then
	    player_dash_trigger.prevvalue = player_dash_trigger.value
	end
	player_dash_trigger.value = nil
	if space_pressed and player_jump_cooldown_timer <= 0 then
	   -- if player_jump_cooldown_timer <= 0 then
	
		    gameWorld[1][1].action = {"jump"}
		    gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_front ) 
			player_jump_cooldown_timer = player_jump_cooldown_time
	    --end
	elseif gameWorld[1][1].action[1] == "jump" then
	    gameWorld[1][1].action = {"walk", 0, 0}
	end
	
	
	
	
	
	local player_fire_cooldown_time = 1
	if player_fire_cooldown_timer == nil then
	    player_fire_cooldown_timer = 0
	end
	if player_fire_cooldown_timer > 0 then
	    player_fire_cooldown_timer = player_fire_cooldown_timer - dt
	end
	if player_fire_trigger == nil then
	    player_fire_trigger = {}
	end
	if lmb_pressed_once[3] and player_fire_cooldown_timer <= 0 then
	    player_fire_trigger.bool = true
		player_fire_trigger.mousepos = {lmb_pressed_once[1], lmb_pressed_once[2]}  -- /proectionCoef
		player_fire_trigger.camerashift = {intcamerax, intcameray}
		player_fire_cooldown_timer = player_fire_cooldown_time
	end
	if not lmb_pressed[3] and player_fire_trigger.bool then
	    --here trigger and player position, as well as lmb_pressed and camera shift will be used to determine angles to fire at
		--[[local--]] mouse_actual_position = {}
		mouse_actual_position[1] = player_fire_trigger.mousepos[1] - player_fire_trigger.camerashift[1]
		mouse_actual_position[2] = (player_fire_trigger.mousepos[2] - player_fire_trigger.camerashift[2])*proectionCoef
		mouse_actual_position[3] = (player_fire_trigger.mousepos[2] - lmb_pressed[2] - (player_fire_trigger.camerashift[2] - intcameray))*proectionCoef
		local feh = mouse_actual_position[1] - self[1][1].x1
		local meh = mouse_actual_position[2] - self[1][1].y1
		local player_fire_asimuth = math.atan2(meh,feh)
		local player_fire_horizon = math.atan2(mouse_actual_position[3] - self[1][1].z1, math.sqrt(meh*meh+feh*feh))
	    gameWorld[1][1].action = {"fire", fireball, player_fire_asimuth, player_fire_horizon, 1}
	    player_fire_trigger.bool = false
		
	elseif gameWorld[1][1].action[1] == "fire" then
	    gameWorld[1][1].action = {"walk", 0, 0}
	end
	    
		
		
		
	--local boss_fire_asimuth = math.atan2(meh,feh)
	--local boss_fire_horizon = math.atan2(self[1][1].z1 - self[1][2].z1,math.sqrt(meh*meh+feh*feh))
	
	
	--[[
	if lmb_pressed_once[3] and not lmb_pressed[3] then
	    lmb_pressed_once[3] = false
	elseif gameWorld[1][1].action[1] == "fire" then
	    gameWorld[1][1].action = {"walk", 0, 0}
	end
	--]]
	--elseif lmb_pressed_once[3] then
	  --  lmb_pressed_once[3] = false
	--end
	
	
	
	
	--boss AI below
	if events[6].caused and not (events[12].caused or events[9].caused) then  --and not victory event caused     --e_toggled then
	    local boss_dash_duration = 0.5
		local boss_channeling_duration = 1
		local boss_fireball_speed_coef = 1
		local boss_burst_cooldown_coef = 1
		local boss_fan_amount_coef = 1
		local boss_fan_duration_coef = 1
	    if diflevel == 1 then
		    boss_dash_duration = boss_dash_duration * 2
		    boss_channeling_duration = boss_channeling_duration * 2
			boss_fireball_speed_coef = 0.7
			boss_burst_cooldown_coef = 1.2
			boss_fan_amount_coef = 0.7
		elseif diflevel == 3 then
		    boss_dash_duration = boss_dash_duration / 2
		    boss_channeling_duration = boss_channeling_duration / 2
			boss_burst_cooldown_coef = 0.5
			boss_fan_duration_coef = 0.5
		end
		--,math.random(360)
		local boss_fire_duration = 0.5 -- no - we will have random duration - and also channeling - or not?
		--local walk_duration = 0.7 - no walking?
		local boss_jump_cooldown_time = 0.5
		if boss_channeling == nil then
	        boss_channeling = false
	    end
		if boss_jump_cooldown_timer == nil then
	        boss_jump_cooldown_timer = 0
	    end
		if boss_jump_cooldown_timer > 0 then
		    boss_jump_cooldown_timer = boss_jump_cooldown_timer - dt
		end
		if boss_action_cooldown_timer == nil then
	        boss_action_cooldown_timer = 0
	    end
		if boss_fire_cooldown_timer == nil then
	        boss_fire_cooldown_timer = 0
	    end
		if boss_fire_cooldown_timer > 0 then
		    boss_fire_cooldown_timer = boss_fire_cooldown_timer - dt
		end
		if boss_fire == nil then
		    boss_fire = {}
		    boss_fire.fired = 0
			boss_fire.total = 0
		end
		
		if boss_channeling and boss_action_cooldown_timer > 0 and boss_action_cooldown_timer - dt <= 0 then  --if channeling and cooldown ends - then fire
		    --set firing attributes here
			--firing attributes: bool, type, total amount, amount fired, cooldown, spread angle
			--also add random angles and speed
			boss_fire.fired = 0
			
			local fire_type_choice = math.random(2)
			if fire_type_choice == 1 then
			    boss_fire.total = math.random(7,30)
			    boss_fire.type = "burst"
				boss_fire.cooldown = math.random()*0.2 + 0.05
				boss_fire.spread = math.rad(math.random(30))
				
			else
			    boss_fire.total = math.random(math.ceil(4*boss_fan_amount_coef),math.ceil(13*boss_fan_amount_coef))
			    boss_fire.type = "fan"
				boss_fire.spread = math.rad(math.random(75))
				prevwasfan = true
			end		
			boss_channeling = false
			boss_action_cooldown_timer = boss_fire_duration
		elseif boss_action_cooldown_timer <= 0 then --if cooldown is done
		    thought = math.random()
		    if thought < 0.3 then
		        --dash here
		    	boss_dash_angle = math.rad(math.random(360))
		    	gameWorld[1][2].action = {"dash", boss_dash_angle, math.random()}
				gameWorld[1][2]:changeCurrentAnim(gameWorld[1][2].idle_front)
		        boss_action_cooldown_timer = boss_dash_duration 
				if prevwasfan ~= nil and prevwasfan == true then
				    boss_action_cooldown_timer = boss_action_cooldown_timer*boss_fan_duration_coef
				    prevwasfan = false
				end
		    else
		        --channeling here
				boss_channeling = true
				gameWorld[1][2]:changeCurrentAnim(gameWorld[1][2].channeling)
		    	boss_action_cooldown_timer = boss_channeling_duration*(math.random()*0.5 + 0.5)
				if prevwasfan ~= nil and prevwasfan == true then
				    boss_action_cooldown_timer = boss_action_cooldown_timer*boss_fan_duration_coef
				    prevwasfan = false
				end
			end
		elseif self[1][2].z1 <= 50 and boss_jump_cooldown_timer <= 0 then
		    self[1][2].action = {"jump"}
		    boss_jump_cooldown_timer = boss_jump_cooldown_time
		else
		    self[1][2].action = {"walk", 0, 0}
			self[1][2]:setWalkAnimation(dt)
		end
	    if boss_action_cooldown_timer > 0 then
		    boss_action_cooldown_timer = boss_action_cooldown_timer - dt
		end
		--if previous health > current, then channeling cancels => new action starts
		if boss_fire.fired < boss_fire.total and boss_fire_cooldown_timer <= 0 then
		    --firing here
			--local starting_angle = 
			local feh = self[1][1].x1 - self[1][2].x1
			local meh = self[1][1].y1 - self[1][2].y1
			local boss_fire_asimuth = math.atan2(meh,feh)
		    local boss_fire_horizon = math.atan2(self[1][1].z1 - self[1][2].z1,math.sqrt(meh*meh+feh*feh))--math.rad(-10)  -- atan between bottom and actual line
			
			
			local current_firing_coef = (math.random()*0.4 + 0.6)
			local a = self[1][1].dx^2 + self[1][1].dy^2 + self[1][1].dz^2 - (current_firing_coef*boss_fireball_speed_coef*fireball.startingSpeed)^2
			local b = 2 * (self[1][1].dx * (self[1][1].x1 - self[1][2].x1) + self[1][1].dy * (self[1][1].y1 - self[1][2].y1) + self[1][1].dz * (self[1][1].z1 - self[1][2].z1))
			local c = (self[1][1].x1 - self[1][2].x1)^2 + (self[1][1].y1 - self[1][2].y1)^2 + (self[1][1].z1 - self[1][2].z1)^2
			
			--local t_needed
			if a ~= 0 and ((b^2) - 4*a*c) >= 0 then
			    t1 = (-b - math.sqrt((b^2) - 4 * a * c)) / (2 * a)
			    t2 = (-b + math.sqrt((b^2) - 4 * a * c)) / (2 * a)
			    if t1 >= 0 and t1 <= math.abs(t2) then
				    t_needed = t1
				elseif t2 >= 0 and t2 <= math.abs(t1) then
				    t_needed = t2
				else
				    t_needed = fireball.timeToLive
				end
			else
			    t_needed = fireball.timeToLive
			end
			
			--above we calculate the angles for firing with advance
			
			local target_with_advance = {self[1][1].x1 + self[1][1].dx*t_needed, self[1][1].y1 + self[1][1].dy*t_needed, self[1][1].z1 + self[1][1].dz*t_needed}
			local boss_fire_asimuth_with_advance = math.atan2(target_with_advance[2] - self[1][2].y1, target_with_advance[1] - self[1][2].x1)
		    local boss_fire_horizon_with_advance = math.atan2(target_with_advance[3] - self[1][2].z1,math.sqrt((target_with_advance[2] - self[1][2].y1)^2+(target_with_advance[1] - self[1][2].x1)^2))
			local boss_final_asimuth = boss_fire_asimuth + (boss_fire_asimuth_with_advance - boss_fire_asimuth)*(math.random()*0.7+0.3)
			local boss_final_horizon = boss_fire_horizon + (boss_fire_horizon_with_advance - boss_fire_horizon)*(math.random()*0.7+0.3)
			if boss_fire.type == "fan" then
			    local interval = boss_fire.spread / boss_fire.total
				
			    gameWorld[1][2].action = {"fire", fireball, boss_final_asimuth + boss_fire.spread*0.5 - interval*boss_fire.fired, boss_final_horizon+(math.random() - math.random())*0.5*math.rad(9), current_firing_coef*boss_fireball_speed_coef}
		    elseif boss_fire.type == "burst" then
			    gameWorld[1][2].action = {"fire", fireball, boss_final_asimuth + (math.random() - math.random())*0.5*boss_fire.spread, boss_final_horizon + (math.random() - math.random())*0.5*boss_fire.spread, current_firing_coef*boss_fireball_speed_coef}
				boss_fire_cooldown_timer = boss_fire.cooldown*boss_burst_cooldown_coef
			end
			boss_fire.fired = boss_fire.fired + 1
			
		end
		--this way fire overrides other boss actions
    elseif self[1][2] ~= nil then
		--self[1][2].action = {"walk", 0, 0}
		--self[1][2]:setWalkAnimation(dt)
	end	
end
function World:updateAnimations(dt)
    local I = 1
    while I <= #(self[1]) do
	    --deal with projectiles and aoes later
	    if self[1][I].bodyType == "character" then
	        self[1][I].currentAnim:update(dt)
		end
	    I = I + 1		
	end
end
function World:actions(dt)
    --actions
	--resist
	local I = 1
	while I <= #(self[1]) do
	    if self[1][I].action ~= nil then 
            if self[1][I].action[1] == "walk" then 
		        -- 2^0.5?
		        --you can write arguments in update - keypressed
	            self[1][I]:walk( dt )
	        elseif self[1][I].action[1] == "jump" then
	            --if self[1][I].onSurface and not self[1][I].jumped then
		            self[1][I].dz = self[1][I].dz + self[1][I].jumpSpeed
		    	    self[1][I].jumped = true
		        --end
			elseif self[1][I].action[1] == "dash" then
			    self[1][I]:dash()
			elseif self[1][I].action[1] == "fire" then
			--try this without deepcopy
			--azimuth and horizon angle - got it
			    local projectile = deepcopy(self[1][I].action[2])
				projectile.x1 = self[1][I].x1 + self[1][I].width/2
				projectile.y1 = self[1][I].y1 + self[1][I].thickness/2
				projectile.z1 = self[1][I].z1 + self[1][I].height/2
				--self[1][I].dx = self[1][I].dx + math.cos(angleXY) * math.sin(angleZX) / self[1][I].mass) * dt
				local lengthXY = math.cos(self[1][I].action[4]) * projectile.startingSpeed
				projectile.dx = --[[self[1][I].dx +--]] math.cos(self[1][I].action[3]) * lengthXY * self[1][I].action[5]
				projectile.dy = --[[self[1][I].dy +--]]  math.sin(self[1][I].action[3]) * lengthXY * self[1][I].action[5]
				projectile.dz = --[[self[1][I].dz +--]]  math.sin(self[1][I].action[4]) * projectile.startingSpeed * self[1][I].action[5]
				projectile.ownership = I
				--deboog[2] = #
				table.insert(self[1], projectile)
            end	
		end
		I = I + 1
    end
end


function World:updateWorld(dt)	
	--velocity
	local I = 1
	while I <= #(self[1]) do
	--gravity
	--write borders for x and y here and in actions
	    if not self[1][I].physicless then
	        self[1][I].dx = self[1][I].dx - self.gravityX * dt
	    	self[1][I].dy = self[1][I].dy - self.gravityY * dt
	    	self[1][I].dz = self[1][I].dz - self.gravityZ * dt
	    	if self[1][I].bodyShape == "box" then
	    	    if self[1][I].z1 - self[1][I].radius == 0 and self[1][I].dz < 0 then
	    	        self[1][I].dz = 0
	    	    end
	    	else
	    	    if self[1][I].z1 == 0 and self[1][I].dz < 0 then
	    	        self[1][I].dz = 0
	    	    end
	    	end
	    
	    	--air friction
	    	--you need to find velocity vector's angle(2 angles) and length - done
            --you may confuse angles		
	    	--make cool arrow for debug - made
	    
	    	local vectLengthXYZsquared = (self[1][I].dx^2 + self[1][I].dy^2 + self[1][I].dz^2)
	    	--local angleXY = 0--math.atan2(self[1][I].dy,self[1][I].dx)
	    	--local angleYZ = 0--math.atan2(self[1][I].dz,self[1][I].dy)
	    	--local angleZX = 0--math.atan2(self[1][I].dx,self[1][I].dz)
	    	local angleXY = math.atan2(self[1][I].dy,self[1][I].dx)
	    	local angleYZ = math.atan2(self[1][I].dz,self[1][I].dy)
	    	local angleZX = math.atan2(self[1][I].dx,self[1][I].dz)
	    	--end
	    	angleXY = angleXY + math.rad(180)
	    	angleYZ = angleYZ + math.rad(180)
	    	angleZX = angleZX + math.rad(180)
	    	local frictionMult = self[1][I].dragCoef * (1.225 / (distanceCoef^3)) * ((self[1][I].radius^2) * math.pi) * (vectLengthXYZsquared) / 2 --make Space(S) of sphere cut here -- or maybe cubical meterss??
	    	local dxCoef, dyCoef, dzCoef = 1,1,1
	    	if math.cos(angleXY) < 0 and math.sin(angleZX) < 0 then
	    	    dxCoef = -1
	    	end
	    	if math.cos(angleYZ) < 0 and math.sin(angleXY) < 0 then
	    	    dyCoef = -1
	    	end
	    	if math.cos(angleZX) < 0 and math.sin(angleYZ) < 0 then
	    	    dzCoef = -1
	    	end
	    	
	    	--debug
        
	    	self[1][I].debuggingdx = dxCoef * (frictionMult * math.cos(angleXY) * math.sin(angleZX) / self[1][I].mass) --* dt
	    	self[1][I].debuggingdy = dyCoef * (frictionMult * math.cos(angleYZ) * math.sin(angleXY) / self[1][I].mass) --* dt
	    	self[1][I].debuggingdz = dzCoef * (frictionMult * math.cos(angleZX) * math.sin(angleYZ) / self[1][I].mass) --* dt
        
	    	-- - - = - + + = + - + = -
	    	-- damn when i walk left dz is unstable - fix it - fixed
	    	if self[1][I].dx ~= 0 then
	    	    self[1][I].dx = self[1][I].dx + dxCoef * (frictionMult * math.cos(angleXY) * math.sin(angleZX) / self[1][I].mass) * dt
	    	end
	    	if self[1][I].dy ~= 0 then
	    	    self[1][I].dy = self[1][I].dy + dyCoef * (frictionMult * math.cos(angleYZ) * math.sin(angleXY) / self[1][I].mass) * dt
	    	end
	    	if self[1][I].dz ~= 0 then
	    	    self[1][I].dz = self[1][I].dz + dzCoef * (frictionMult * math.cos(angleZX) * math.sin(angleYZ) / self[1][I].mass) * dt
	    	end
	    	local onGround = false
	        if self[1][I].bodyShape == "box" then
	    	    if self[1][I].z1 == 0  then
	    		    onGround = true
	    		    if self[1][I].dz < 0 then
	    	            self[1][I].dz = 0
	    			end
	    	    end
	    	else
	    	    if self[1][I].z1 - self[1][I].radius  == 0 then
	    		    onGround = true
	    		    if self[1][I].dz < 0 then
	    	            self[1][I].dz = 0
	    			end
	    	    end
	    	end
	    	--land friction
	    	--do we actually need vectLengthXY here? - NO
	    	if onGround then
	    	    if self[1][I].dx ~= 0 or self[1][I].dy ~= 0 then
	    	        angleXY = math.atan2(self[1][I].dy,self[1][I].dx)
	    		    if self[1][I].dx < 0 then
	    		        self[1][I].dx = self[1][I].dx - math.cos(angleXY) * 0.3 * self.gravityZ * dt
	    			    if self[1][I].dx > 0 then
	    			        self[1][I].dx = 0
	    			    end
	    		    elseif self[1][I].dx > 0 then
	    		        self[1][I].dx = self[1][I].dx - math.cos(angleXY) * 0.3 * self.gravityZ * dt
	    			    if self[1][I].dx < 0 then
	    			        self[1][I].dx = 0
	    			    end
	    		    end
	    		    if self[1][I].dy < 0 then
	    		        self[1][I].dy = self[1][I].dy - math.sin(angleXY) * 0.3 * self.gravityZ * dt
	    			    if self[1][I].dy > 0 then
	    			        self[1][I].dy = 0
	    			    end
	    		    elseif self[1][I].dy > 0 then
	    		        self[1][I].dy = self[1][I].dy - math.sin(angleXY) * 0.3 * self.gravityZ * dt
	    			    if self[1][I].dy < 0 then
	    			        self[1][I].dy = 0
	    			    end
	    		    end
	    	    end
	    	end
	    end	
	    I = I + 1
	end
	I = 1
	--position
	
	--cut velocity to prevent intersection? determine voronoi region?
    while I <= #self[1] do
	    if self[1][I].bodyShape == "box" then
	        self[1][I].prevx1 = self[1][I].x1
	        self[1][I].prevx2 = self[1][I].x1 + self[1][I].width
	        self[1][I].prevy1 = self[1][I].y1
	        self[1][I].prevy2 = self[1][I].y1 + self[1][I].thickness
	        self[1][I].prevz1 = self[1][I].z1
	        self[1][I].prevz2 = self[1][I].z1 + self[1][I].height
	        self[1][I].prevcenterx = self[1][I].x1 + self[1][I].width / 2
	        self[1][I].prevcentery = self[1][I].y1 + self[1][I].thickness / 2
	        self[1][I].prevcenterz = self[1][I].z1 + self[1][I].height / 2
		end
	    self[1][I].x1 = self[1][I].x1 + self[1][I].dx * dt
	    self[1][I].y1 = self[1][I].y1 + self[1][I].dy * dt
	    self[1][I].z1 = self[1][I].z1 + self[1][I].dz * dt
	    --width and depth (x and y here too)
		--maybe you could improve these queries
		if self[1][I].bodyShape == "box" then
	        if self[1][I].z1 < 0 then
	            self[1][I].z1 = 0
		    	self[1][I].surfaceTimer = 0
		        self[1][I].onSurface = true
		    	self[1][I].jumped = false
	        elseif self[1][I].z1 == 0 then
		        self[1][I].surfaceTimer = 0
	            self[1][I].onSurface = true
		    	self[1][I].jumped = false
	        elseif self[1][I].bodyType == "character" then
		        if self[1][I].surfaceTimer >= 0.1 then
		            --put some kind of delay on it like 0.1 second
	                self[1][I].onSurface = false			
		        else
		            self[1][I].surfaceTimer = self[1][I].surfaceTimer + dt
		    	end
		    elseif self[1][I].onSurface == true then
		        self[1][I].onSurface = false
	        end
		else
		    if self[1][I].z1 - self[1][I].radius < 0 then
	            self[1][I].z1 = self[1][I].radius
		    	self[1][I].surfaceTimer = 0
		        self[1][I].onSurface = true
		    	self[1][I].jumped = false
	        elseif self[1][I].z1 - self[1][I].radius == 0 then
		        self[1][I].surfaceTimer = 0
	            self[1][I].onSurface = true
		    	self[1][I].jumped = false
			else
			    self[1][I].onSurface = false
			end
		end
	    I = I + 1
    end
	
--collision
    I = 1
	-- N is for preventing unwanted collisions if new objects appear
	local N = #self[1]
    while I <= (N - 1) do
	    local J = I + 1
		while J <= N do
		
		--collision detection can be optimized
		    if self[1][I].bodyShape == "box" and self[1][J].bodyShape == "box" then
			    --workaround of continue
				if not( self[1][I].x1 + self[1][I].width < self[1][J].x1 ) and not( self[1][J].x1 + self[1][J].width < self[1][I].x1 )  then
					if not( self[1][I].y1 + self[1][I].thickness < self[1][J].y1 ) and not( self[1][J].y1 + self[1][J].thickness < self[1][I].y1 ) then
						if not( self[1][I].z1 + self[1][I].height < self[1][J].z1 ) and not( self[1][J].z1 + self[1][J].height < self[1][I].z1 ) then
							--put inside bodyType queries
							
							--collide
							--(1+e) <- elasticity
							-- VX VY VZ
							collidedBool = true
							local onTop = false
							local VX = self[1][I].dx - self[1][J].dx
							local VY = self[1][I].dy - self[1][J].dy
							local VZ = self[1][I].dz - self[1][J].dz
							local xdepth, ydepth, zdepth = 0, 0, 0
							--[[
							if VX > 0 then
								xdepth = self[1][I].x1 + self[1][I].width - self[1][J].x1 + padding
							elseif VX < 0 then
								xdepth = self[1][J].x1 + self[1][J].width - self[1][I].x1 + padding
							end
							if VY > 0 then
								ydepth = self[1][I].y1 + self[1][I].thickness - self[1][J].y1 + padding
							elseif VY < 0 then
								ydepth = self[1][J].y1 + self[1][J].thickness - self[1][I].y1 + padding
							end
							if VZ > 0 then
								zdepth = self[1][I].z1 + self[1][I].height - self[1][J].z1 + padding
							elseif VZ < 0 then
								zdepth = self[1][J].z1 + self[1][J].height - self[1][I].z1 + padding
							end
							--]]
							local absdx1plusdx2 = math.abs(self[1][I].dx) + math.abs(self[1][J].dx)
							local absdy1plusdy2 = math.abs(self[1][I].dy) + math.abs(self[1][J].dy)
							local absdz1plusdz2 = math.abs(self[1][I].dz) + math.abs(self[1][J].dz)
							--maybe better to use time? or not.
							voronoix, voronoiy, voronoiz = 0, 0, 0
							--amn you i forgot that it could be not only speed but teleportation by collision
							if self[1][I].prevx2 < self[1][J].prevx1 then
								if absdx1plusdx2 == 0 then
									absdx1plusdx2 = 2
								end
									xdepth = self[1][I].x1 + self[1][I].width - self[1][J].x1 + padding
									self[1][I].x1 = self[1][I].x1 - xdepth / 2 --* (math.abs(self[1][I].dx)/absdx1plusdx2)
									self[1][J].x1 = self[1][J].x1 + xdepth / 2 --* (math.abs(self[1][J].dx)/absdx1plusdx2)
								
								voronoix = -1
								
							elseif self[1][I].prevx1 > self[1][J].prevx2 then
								if absdx1plusdx2 == 0 then
									absdx1plusdx2 = 2
								end
								xdepth = self[1][J].x1 + self[1][J].width - self[1][I].x1 + padding
								self[1][I].x1 = self[1][I].x1 + xdepth /2--* (math.abs(self[1][I].dx)/absdx1plusdx2)
								self[1][J].x1 = self[1][J].x1 - xdepth /2--* (math.abs(self[1][J].dx)/absdx1plusdx2)
								
								voronoix = 1	
														
							end
							if self[1][I].prevy2 < self[1][J].prevy1 then
							if absdy1plusdy2 == 0 then
								absdy1plusdy2 = 2
							end
								ydepth = self[1][I].y1 + self[1][I].thickness - self[1][J].y1 + padding
								
								self[1][I].y1 = self[1][I].y1 - ydepth /2--* (math.abs(self[1][I].dy)/absdy1plusdy2)
								self[1][J].y1 = self[1][J].y1 + ydepth /2--* (math.abs(self[1][J].dy)/absdy1plusdy2)							
								voronoiy = -1
								
							elseif self[1][I].prevy1 > self[1][J].prevy2 then
							if absdy1plusdy2 == 0 then
								absdy1plusdy2 = 2
							end  
								ydepth = self[1][J].y1 + self[1][J].thickness - self[1][I].y1 + padding
								self[1][I].y1 = self[1][I].y1 + ydepth /2--* (math.abs(self[1][I].dy)/absdy1plusdy2)
								self[1][J].y1 = self[1][J].y1 - ydepth /2--* (math.abs(self[1][J].dy)/absdy1plusdy2)
								voronoiy = 1   								
							end
							--guy below "shrinks" - make guy on surface resist - done
							if self[1][I].prevz2 < self[1][J].prevz1 then
							
								self[1][J].surfaceTimer = 0
								self[1][J].onSurface = true	
								self[1][J].jumped = false
								if absdz1plusdz2 == 0 then
									absdz1plusdz2 = 2
								end							
								zdepth = self[1][I].z1 + self[1][I].height - self[1][J].z1 + padding
								if self[1][I].onSurface then
									self[1][J].z1 = self[1][J].z1 + zdepth
								else
									self[1][I].z1 = self[1][I].z1 - zdepth /2--* (math.abs(self[1][I].dz)/absdz1plusdz2)
									self[1][J].z1 = self[1][J].z1 + zdepth /2--* (math.abs(self[1][J].dz)/absdz1plusdz2)
								end
								voronoiz = -1
								onTop = true
							elseif self[1][I].prevz1 > self[1][J].prevz2 then
								self[1][I].surfaceTimer = 0
								self[1][I].onSurface = true
								self[1][I].jumped = false
								if absdz1plusdz2 == 0 then
									absdz1plusdz2 = 2
								end			
								zdepth = self[1][J].z1 + self[1][J].height - self[1][I].z1 + padding
								if self[1][J].onSurface then
									self[1][I].z1 = self[1][I].z1 + zdepth
								else							
									self[1][I].z1 = self[1][I].z1 + zdepth /2--* (math.abs(self[1][I].dz)/absdz1plusdz2)
									self[1][J].z1 = self[1][J].z1 - zdepth /2--* (math.abs(self[1][J].dz)/absdz1plusdz2)
								end
								voronoiz = 1 
								onTop = true
							end
							if voronoix == 0 and voronoiy == 0 and voronoiz == 0 then
								--min depth - better surfacing
								--FIX IT
								--[[local--]] depth = {{},--[[{1,1,1}}--]]{(self[1][I].width + self[1][J].width)/2, (self[1][I].thickness + self[1][J].thickness)/2, (self[1][I].height + self[1][J].height)/2}}
								depth[1][1] = self[1][I].x1 + self[1][I].width - self[1][J].x1 + padding
								depth[1][2] = -(self[1][J].x1 + self[1][J].width - self[1][I].x1  + padding)
								depth[1][3] = self[1][I].y1 + self[1][I].thickness - self[1][J].y1 + padding
								depth[1][4] = -(self[1][J].y1 + self[1][J].thickness - self[1][I].y1 + padding)
								depth[1][5] = self[1][I].z1 + self[1][I].height - self[1][J].z1 + padding
								depth[1][6] = -(self[1][J].z1 + self[1][J].height - self[1][I].z1 + padding)
								
								local K, N = 2, 1
								while K <= 6 do
									if math.abs(depth[1][K] / depth[2][math.ceil(K/2)]) < math.abs(depth[1][N] / depth[2][math.ceil(N/2)]) then
										N = K
									end
								    K = K + 1
								end
								debugging = "blah"
								if N == 1 or N == 2 then
									debugging = "yes"
									self[1][I].x1 = self[1][I].x1 - depth[1][N] / 2
									self[1][J].x1 = self[1][J].x1 + depth[1][N] / 2
								elseif N == 3 or N == 4 then
									self[1][I].y1 = self[1][I].y1 - depth[1][N] / 2
									self[1][J].y1 = self[1][J].y1 + depth[1][N] / 2
								else
									if depth[1][N] > 0 then
										self[1][J].surfaceTimer = 0
										self[1][J].onSurface = true
										self[1][J].jumped = false
										if self[1][I].onSurface then
											self[1][J].z1 = self[1][J].z1 + depth[1][N]
										else
											self[1][I].z1 = self[1][I].z1 - depth[1][N] / 2
											self[1][J].z1 = self[1][J].z1 + depth[1][N] / 2
										end
									else
										self[1][I].surfaceTimer = 0
										self[1][I].onSurface = true
										self[1][I].jumped = false
										if self[1][J].onSurface then
											self[1][I].z1 = self[1][I].z1 - depth[1][N]
										else
											self[1][I].z1 = self[1][I].z1 - depth[1][N] / 2
											self[1][J].z1 = self[1][J].z1 + depth[1][N] / 2
										end
									end
									
									onTop = true
								end
							end
							if self[1][I].z1 < 0 then
								self[1][I].z1 = 0
							end
							local m1plusm2 = self[1][I].mass + self[1][J].mass
							local m1minusm2 = self[1][I].mass - self[1][J].mass
							local m1multby2 = self[1][I].mass * 2
							-- m1*v1i + m2*v2i = m1*v1f + m2*v2f
							--using conservation of kinetic energy?
							-- self[1][I].mass - self[1][J].mass
							--26 regions
							
							if onTop == false then
								self[1][I].dx = self[1][J].dx + 1 * VX * (m1minusm2 / m1plusm2)
								self[1][J].dx = self[1][J].dx + 1 * VX * (m1multby2 / m1plusm2)
								self[1][I].dy = self[1][J].dy + 1 * VY * (m1minusm2 / m1plusm2)
								self[1][J].dy = self[1][J].dy + 1 * VY * (m1multby2 / m1plusm2)					
							end
							self[1][I].dz = self[1][J].dz + 1 * VZ * (m1minusm2 / m1plusm2)
							self[1][J].dz = self[1][J].dz + 1 * VZ * (m1multby2 / m1plusm2)
							--for starters make something simple(not nesessary down here) 
						end
					end
				end
			elseif self[1][I].bodyShape == "sphere" and self[1][J].bodyShape == "box" then
			    --if self:testSphereAgainstBox( I, J ) <= self[1][I].radius then
				self:collisionOfSphereAndBox( I, J )
				
			elseif self[1][I].bodyShape == "box" and self[1][J].bodyShape == "sphere" then
			    --if self:testSphereAgainstBox( J, I ) <= self[1][J].radius then
				self:collisionOfSphereAndBox( J, I )
				
			elseif self[1][I].bodyType == "aoe" and self[1][J].bodyType == "projectile" then
				self:collisionOfAoEandProjectile( I, J )
				
			elseif self[1][I].bodyType == "projectile" and self[1][J].bodyType == "aoe" then
				self:collisionOfAoEandProjectile( J, I )
			
		    end
		    J = J + 1
		end	
	    I = I + 1     
	end
	return true
end

function World:destroy(dt)
    local I = 1
	--this is a subject to change
	
	while I <= (#self[1]) do
	--[[if self[1][I].bodyShape == "box" then
            if self[1][I].curHP <= 0 then
			    self[1][I].toDestroy = true
            end
		end
		--]]
		--stuff with time to live lives one frame later
		if self[1][I].timeToLive ~= nil and self[1][I].lifetime ~= nil then		    
			if self[1][I].lifetime > self[1][I].timeToLive then
			    self[1][I].toDestroy = true
			end
            self[1][I].lifetime = self[1][I].lifetime + dt			
		end
	    I = I + 1
	end
	--[[I = 1
	while I <= (#self[1]) do
	    if self[1][I].bodyShape == "sphere" then --or hitbox or someting 
		    if self[1][I].ownership ~= nil then
		        if self[1][self[1][I].ownership].toDestroy then
			        self[1][I].ownership = nil
			    end
			end
		end
	    I = I + 1
	end--]]
	I = 1
    while I <= (#self[1]) do
	    if self[1][I].toDestroy then 
		    table.remove(self[1], I)
		else
		    I = I + 1
		end	    
	end
	
end



function love.load()
    love.window.setTitle("Very powerful wizard")
    license = love.graphics.newImage("sprites/license.png")


	
    debwog = {}
	debwog[1] = 0
	debwog[2] = 0
	debwog[3] = 0
	debwog[4] = 0
  
    mouse_actual_position = {0,0,0}

    math.randomseed(os.time())
	lmb_pressed_once = {0,0,false}
	lmb_pressed = {0,0,false}
	
    replyBounds = { 150, 40, width = 150, height = 15, gapY = 20 }

	--Phrase = { }
	--Reply = { }
	--currentPhrase = {}
	--[[
    firstDialogue = setmetatable({ text = "Hello", talker = necromancer }, {__index = Phrase})
	firstDialogue[1] = setmetatable({{ text = "..." }}, {__index = Reply})
	firstDialogue[1][1] = setmetatable({ setmetatable({ text = "what" }, {__index = Reply}), setmetatable({ text = "20" }, {__index = Reply}), setmetatable({ text = "30" }, {__index = Reply}), text = "Choose an answer wizely", talker = necromancer }, {__index = Phrase})
    firstDialogue[1][1][1][1] = setmetatable({ text = "What kind of answer is that?", talker = necromancer }, {__index = Phrase})
	firstDialogue[1][1][2][1] = setmetatable({ text = "You chose unwizely", talker = necromancer }, {__index = Phrase})
	firstDialogue[1][1][3][1] = setmetatable({ text = "You chose wizely", talker = necromancer }, {__index = Phrase})--]]
	--currentPhrase = {"blahblahblah! blah", "blahhahahah", "blahbalalah", "blalala", "balalala", "blahlahlah", "blah", "blahblah"}
    
	--or maybe timer = {global = 0, default = 0, ...} <<<
	
	currentPhrase = nil
	--timers = {global = 0, current = 0}!!!
	timers = {global = 0, current = 0}
	--start, default, necromancer
	--events = {start = {{occured = false}}, default = {}, necromancer = {}, demons = {}, illusionist = {}, ninjas = {}, cat = {}, victory = {}}
	--set in metatable that ocured = false ?
	events[1] = {caused = false}
	--events[1].cause_arguments = { 4 }
	events[1].cause = cause1
	--events[1].effect_arguments = { 5 }
	events[1].effect = effect1	
	events[2] = {caused = false}
	events[2].cause = cause2
	events[2].effect = effect2
	events[3] = {caused = false}
	events[3].cause = cause3
	events[3].effect = effect3
	events[4] = {caused = false}
	events[4].cause = cause4
	events[4].effect = effect4
	events[5] = {caused = false}
	events[5].cause = cause5
	events[5].effect = effect5
	events[6] = {caused = false}
	events[6].cause = cause6
	events[6].effect = effect6
	events[7] = {caused = false}
	events[7].cause = cause7
	events[7].effect = effect7
	events[8] = {caused = false}
	events[8].cause = cause8
	events[8].effect = effect8
	events[9] = {caused = false}
	events[9].cause = cause9
	events[9].effect = effect9
	events[10] = {caused = false}
	events[10].cause = cause10
	events[10].effect = effect10
	events[11] = {caused = false}
	events[11].cause = cause11
	events[11].effect = effect11
	events[12] = {caused = false}
	events[12].cause = cause12
	events[12].effect = effect12
	events[13] = {caused = false}
	events[13].cause = cause13
	events[13].effect = effect13
	--[[events.start[1].occurance = function()
	if timers.global >= self.occurance_arguments[1] and self.occured == false then
		return true
	else
		return false
	end
end
	--]]
	ring_of_spheres = {400, 300, 250}
	--game state: credits, general game, conversation
    gameState = "noAI"
    proectionCoef = 2^0.5
    --ring: x,y,radius
	--fireball_timer = 0
    deboog = {}	
	deboog[1] = math.atan2(0,0)
	deboog[3] = 3
	angle = math.rad(90)
    padding = 0.1
	gameWorld = setmetatable({{}}, {__index = World})
    w_pressed = false
	a_pressed = false
	s_pressed = false
	d_pressed = false
	up_pressed = false
	left_pressed = false
	down_pressed = false
	right_pressed = false
	space_pressed = false
	e_toggled = false
	tab_toggled = false
	return_pressed_once = false
	collidedBool = false
	--debug
	--
	camerax, cameray, intcamerax, intcameray = 0, 0, 0, 0
	scroll_speed = 100
	fireball_explosion = setmetatable({ radius = 20, maxForce = 800, timeToLive = 0 }, {__index = Explosion})
	fireball = setmetatable({ mass = 15.0, damage = 1, dragCoef = 0.05, physicless = true, timeToLive = 6, explosion = fireball_explosion },  {__index = ImpactExplosionProjectile})
	fireball_sprite = love.graphics.newImage("projectiles/fireball.png")
    fireball.radius = (fireball_sprite:getHeight()/2)
	fireball.sprite = {currentImg = fireball_sprite}
	grass = love.graphics.newImage("tiles/grass.png")
	stone = love.graphics.newImage("tiles/stone.png")
	sphere = love.graphics.newImage("sprites/sphere.png")
	
	
	necromancer = setmetatable({type = "necromancer", thickness = 21, mass = 50.0, movementSpeed = 40.0, movementAcceleration = 80.0, jumpSpeed = 120.0, maxHP = 5, curHP = 5},  {__index = Character})
	local necromancer_walk_up_1_3 = love.graphics.newImage("sprites/necromancer_walk_up_1-3.png")
	local necromancer_walk_up_2_4 = love.graphics.newImage("sprites/necromancer_walk_up_2-4.png")
	local necromancer_walk_side_1_3 = love.graphics.newImage("sprites/necromancer_walk_side_1-3.png")
	local necromancer_walk_side_2 = love.graphics.newImage("sprites/necromancer_walk_side_2.png")
	local necromancer_walk_side_4 = love.graphics.newImage("sprites/necromancer_walk_side_4.png")
	local necromancer_walk_down_1_3 = love.graphics.newImage("sprites/necromancer_walk_down_1-3.png")
	local necromancer_walk_down_2_4 = love.graphics.newImage("sprites/necromancer_walk_down_2-4.png")
	necromancer.idle_back = setmetatable({currentImg = {image = love.graphics.newImage("sprites/necromancer_idle_back.png"), flipX = false}, static = true}, {__index = Animation})
	necromancer.idle_left = setmetatable({currentImg = {image = love.graphics.newImage("sprites/necromancer_idle_side.png"), flipX = true}, static = true}, {__index = Animation})
	necromancer.idle_front = setmetatable({currentImg = {image = love.graphics.newImage("sprites/necromancer_idle_front.png"), flipX = false}, static = true}, {__index = Animation})
	necromancer.idle_right = setmetatable({currentImg = {image = necromancer.idle_left.currentImg.image, flipX = false}, static = true}, {__index = Animation})
	necromancer.channeling = setmetatable({currentImg = {image = love.graphics.newImage("sprites/necromancer_channeling.png"), flipX = false}, static = true}, {__index = Animation})
	necromancer.walk_up = setmetatable({{{image = necromancer_walk_up_1_3, flipX = false}, {image = necromancer_walk_up_2_4, flipX = false}, {image = necromancer_walk_up_1_3, flipX = false}, {image = necromancer_walk_up_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	necromancer.walk_left = setmetatable({{{image = necromancer_walk_side_1_3, flipX = true }, {image = necromancer_walk_side_2, flipX = true}, {image = necromancer_walk_side_1_3, flipX = true}, {image = necromancer_walk_side_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	necromancer.walk_down = setmetatable({{{image = necromancer_walk_down_1_3, flipX = false}, {image = necromancer_walk_down_2_4, flipX = false}, {image = necromancer_walk_down_1_3, flipX = false}, {image = necromancer_walk_down_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	necromancer.walk_right = setmetatable({{{image = necromancer_walk_side_1_3, flipX = false }, {image = necromancer_walk_side_2, flipX = false}, {image = necromancer_walk_side_1_3, flipX = false}, {image = necromancer_walk_side_4, flipX = false}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	necromancer.currentAnim = necromancer.idle_front
	necromancer.width = necromancer.idle_front.currentImg.image:getWidth() - 4
	necromancer.height = (necromancer.idle_front.currentImg.image:getHeight())*(proectionCoef)
	necromancer.radius = ((necromancer.width/2)^2 + (necromancer.thickness/2)^2 + (necromancer.height/2)^2)^0.5
	
	skeleton = setmetatable({type = "skeleton", thickness = 21, mass = 5.0, movementSpeed = 80.0, movementAcceleration = 100.0, jumpSpeed = 120.0, maxHP = 100, curHP = 100},  {__index = Character})
	local skeleton_walk_up_1_3 = love.graphics.newImage("sprites/skeleton_walk_up_1-3.png")
	local skeleton_walk_up_2_4 = love.graphics.newImage("sprites/skeleton_walk_up_2-4.png")
	local skeleton_walk_side_1_3 = love.graphics.newImage("sprites/skeleton_walk_side_1-3.png")
	local skeleton_walk_side_2 = love.graphics.newImage("sprites/skeleton_walk_side_2.png")
	local skeleton_walk_side_4 = love.graphics.newImage("sprites/skeleton_walk_side_4.png")
	local skeleton_walk_down_1_3 = love.graphics.newImage("sprites/skeleton_walk_down_1-3.png")
	local skeleton_walk_down_2_4 = love.graphics.newImage("sprites/skeleton_walk_down_2-4.png")
	skeleton.idle_back = setmetatable({currentImg = {image = love.graphics.newImage("sprites/skeleton_idle_back.png"), flipX = false}, static = true}, {__index = Animation})
	skeleton.idle_left = setmetatable({currentImg = {image = love.graphics.newImage("sprites/skeleton_idle_side.png"), flipX = true}, static = true}, {__index = Animation})
	skeleton.idle_front = setmetatable({currentImg = {image = love.graphics.newImage("sprites/skeleton_idle_front.png"), flipX = false}, static = true}, {__index = Animation})
	skeleton.idle_right = setmetatable({currentImg = {image = skeleton.idle_left.currentImg.image, flipX = false}, static = true}, {__index = Animation})
	skeleton.walk_up = setmetatable({{{image = skeleton_walk_up_1_3, flipX = false}, {image = skeleton_walk_up_2_4, flipX = false}, {image = skeleton_walk_up_1_3, flipX = false}, {image = skeleton_walk_up_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	skeleton.walk_left = setmetatable({{{image = skeleton_walk_side_1_3, flipX = true }, {image = skeleton_walk_side_2, flipX = true}, {image = skeleton_walk_side_1_3, flipX = true}, {image = skeleton_walk_side_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	skeleton.walk_down = setmetatable({{{image = skeleton_walk_down_1_3, flipX = false}, {image = skeleton_walk_down_2_4, flipX = false}, {image = skeleton_walk_down_1_3, flipX = false}, {image = skeleton_walk_down_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	skeleton.walk_right = setmetatable({{{image = skeleton_walk_side_1_3, flipX = false }, {image = skeleton_walk_side_2, flipX = false}, {image = skeleton_walk_side_1_3, flipX = false}, {image = skeleton_walk_side_4, flipX = false}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	skeleton.currentAnim = skeleton.idle_front
	skeleton.width = skeleton.idle_front.currentImg.image:getWidth() - 4
	skeleton.height = (skeleton.idle_front.currentImg.image:getHeight())*(proectionCoef)
	skeleton.radius = ((skeleton.width/2)^2 + (skeleton.thickness/2)^2 + (skeleton.height/2)^2)^0.5
	
		
	demon = setmetatable({type = "demon", thickness = 21, mass = 1.0, dragCoef = 0.05, movementSpeed = 140.0, movementAcceleration = 400.0, jumpSpeed = 120.0, maxHP = 15, curHP = 15},  {__index = Character})
	local demon_walk_up_1_3 = love.graphics.newImage("sprites/demon_walk_up_1-3.png")
	local demon_walk_up_2_4 = love.graphics.newImage("sprites/demon_walk_up_2-4.png")
	local demon_walk_side_1_3 = love.graphics.newImage("sprites/demon_walk_side_1-3.png")
	local demon_walk_side_2 = love.graphics.newImage("sprites/demon_walk_side_2.png")
	local demon_walk_side_4 = love.graphics.newImage("sprites/demon_walk_side_4.png")
	local demon_walk_down_1_3 = love.graphics.newImage("sprites/demon_walk_down_1-3.png")
	local demon_walk_down_2_4 = love.graphics.newImage("sprites/demon_walk_down_2-4.png")
	demon.idle_back = setmetatable({currentImg = {image = love.graphics.newImage("sprites/demon_idle_back.png"), flipX = false}, static = true}, {__index = Animation})
	demon.idle_left = setmetatable({currentImg = {image = love.graphics.newImage("sprites/demon_idle_side.png"), flipX = true}, static = true}, {__index = Animation})
	demon.idle_front = setmetatable({currentImg = {image = love.graphics.newImage("sprites/demon_idle_front.png"), flipX = false}, static = true}, {__index = Animation})
	demon.idle_right = setmetatable({currentImg = {image = demon.idle_left.currentImg.image, flipX = false}, static = true}, {__index = Animation})
	demon.walk_up = setmetatable({{{image = demon_walk_up_1_3, flipX = false}, {image = demon_walk_up_2_4, flipX = false}, {image = demon_walk_up_1_3, flipX = false}, {image = demon_walk_up_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	demon.walk_left = setmetatable({{{image = demon_walk_side_1_3, flipX = true }, {image = demon_walk_side_2, flipX = true}, {image = demon_walk_side_1_3, flipX = true}, {image = demon_walk_side_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	demon.walk_down = setmetatable({{{image = demon_walk_down_1_3, flipX = false}, {image = demon_walk_down_2_4, flipX = false}, {image = demon_walk_down_1_3, flipX = false}, {image = demon_walk_down_2_4, flipX = true}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	demon.walk_right = setmetatable({{{image = demon_walk_side_1_3, flipX = false }, {image = demon_walk_side_2, flipX = false}, {image = demon_walk_side_1_3, flipX = false}, {image = demon_walk_side_4, flipX = false}}, {1.0/4, 1.0/4 ,1.0/4, 1.0/4}}, {__index = Animation})
	demon.currentAnim = demon.idle_front
	demon.width = demon.idle_front.currentImg.image:getWidth() - 4
	demon.height = (demon.idle_front.currentImg.image:getHeight())*(proectionCoef)
	demon.radius = ((demon.width/2)^2 + (demon.thickness/2)^2 + (demon.height/2)^2)^0.5
	
	
	currentTalker = skeleton
	
	--temporary measure
	gameWorld[1][1] = deepcopy(demon)
	gameWorld[1][1].x1 = 400.0 - (demon.width/2)
	gameWorld[1][1].y1 = 300.0 *proectionCoef
	gameWorld[1][1].mass = 40.0
	gameWorld[1][1].dragCoef = 1.0

	gameWorld[1][2] = deepcopy(necromancer)
    gameWorld[1][2].x1 = 400.0 - (necromancer.width/2)
	gameWorld[1][2].y1 = -20.0
	gameWorld[1][2].mass = 1000
	gameWorld[1][3] = deepcopy(skeleton)
    gameWorld[1][3].x1 = 450.0
	gameWorld[1][3].y1 = 300.0*proectionCoef
	--gameWorld[1][4] = deepcopy(demon)
    --gameWorld[1][4].x1 = 100.0
	--gameWorld[1][4].y1 = 200.0
	
	
	gameWorld[1][1]:changeCurrentAnim(gameWorld[1][1].idle_front)
	gameWorld[1][2]:changeCurrentAnim(gameWorld[1][2].idle_front)
	gameWorld[1][3]:changeCurrentAnim(gameWorld[1][3].idle_front)
	
end



--dialogue.function = myfunc;
--dialogue.function(dialogue)
--[[
function events.start[1]:occurance()
	if timers.global >= self.occurance_arguments[1] and self.occured == false then
		return true
	else
		return false
	end
end
--]]



function love.update(dt)
    --damnn how to reset animation? maybe make function that changes animation? - done - and maybe make animation reset an option?
	
    framerate = 1/dt
	--[[
	if return_pressed_once then
	    if gameState == "general game" then
	        gameState = "conversation"
		elseif gameState == "conversation" then
		    gameState = "general game"
		end
        return_pressed_once = false
	end--]]
	local I = 1
	if gameState == "general game"  then
	    gameWorld:AI(dt)
    end
	if gameState == "general game" or gameState == "noAI" then
	    
		gameWorld:updateAnimations(dt)
		gameWorld:actions(dt)
	    gameWorld:updateWorld(dt)
		gameWorld:destroy(dt)
		
		timers.global = timers.global + dt
	    timers.current = timers.current + dt
	elseif gameState == "conversation" and currentPhrase ~= nil then
	    I = currentPhrase:chooseReply() 
		if I ~= 0 then
		    local J = currentPhrase[I].choosePhrase()
			--if currentPhrase[I][J] ~= nil then
		    currentPhrase = currentPhrase[I][J]  -- deepcopy?
			--when currentPhrase == nil, forward there will be stopping mechanism - like inside events?
		end
	end
	I = 1
	while I <= #events do
	    if events[I].cause(events[I]) then
		    events[I].caused = true
	        events[I].effect(events[I],dt)
	    end
	    I = I + 1
	end
	--[[
	if up_pressed then
	    cameray = cameray + (scroll_speed * dt)
		intcameray = math.ceil(cameray)
	end
	if left_pressed then
	    camerax = camerax + (scroll_speed * dt)
		intcamerax = math.ceil(camerax)
	end
	if down_pressed then
	    cameray = cameray - (scroll_speed * dt)
		intcameray = math.ceil(cameray)
	end
	if right_pressed then
	    camerax = camerax - (scroll_speed * dt)
		intcamerax = math.ceil(camerax)
    end
	--]]

	lmb_pressed_once[3] = false
end
function love.draw()
    love.graphics.translate( intcamerax, intcameray )
	love.graphics.setColor(255,255,255)
	
	local L = 0 --6
	while L < 18 + 1 do
	    local M = 0
	    while M < 24 + 1 do
		    love.graphics.draw( stone, M * 32, L * 32 )
		    M = M + 1
		end
	    L = L + 1
	end
	--local angle = 0
	--while angle < 360 do
	--	love.graphics.draw( sphere, math.cos(math.rad(angle))*ring_of_spheres[3] + ring_of_spheres[1], (math.sin(math.rad(angle))*ring_of_spheres[3] + ring_of_spheres[2])/(proectionCoef) )
	--	angle = angle + 22.5
	--end
	love.graphics.setColor(0,0,0,128)--85)
	local I = 1	
	while I <= #(gameWorld[1]) do
	    if gameWorld[1][I].bodyShape == "box" then
	        love.graphics.circle( "fill", gameWorld[1][I].x1 + gameWorld[1][I].width / 2, (gameWorld[1][I].y1 + gameWorld[1][I].thickness/2)/(proectionCoef), gameWorld[1][I].width / 2--[[( (gameWorld[1][I].z1^0.1 + 2))--]], 30 )
		else
		    love.graphics.circle( "fill", gameWorld[1][I].x1, gameWorld[1][I].y1/(proectionCoef), gameWorld[1][I].radius--[[( (gameWorld[1][I].z1^0.1 + 2))--]], 30 )
		end
		I = I + 1
	end
	love.graphics.setColor(255,255,255)
	--sorting algorithm can be changed too
	I = 1
	local drawingOrder = {}
	while I <= #(gameWorld[1]) do
	    drawingOrder[I] = I
		I = I + 1
	end
	I = 1
	while I <= (#drawingOrder - 1) do
	    local MIN, J = I, I + 1
	    while J <= #drawingOrder do
		    if (gameWorld[1][drawingOrder[J]].y1 + gameWorld[1][drawingOrder[J]].thickness / 2) < (gameWorld[1][drawingOrder[MIN]].y1 + gameWorld[1][drawingOrder[MIN]].thickness / 2) then
			    MIN = J
		    end
		    J = J + 1
		end
		if I ~= MIN then
		    local buff = drawingOrder[I]
		    drawingOrder[I] = drawingOrder[MIN]
		    drawingOrder[MIN] = buff
		end
		I = I + 1
	end
	I = 1
	while I <= #drawingOrder do
	    if gameWorld[1][drawingOrder[I]].bodyType == "character" then
	        gameWorld[1][drawingOrder[I]]:drawCharacter()
		elseif gameWorld[1][drawingOrder[I]].bodyType == "projectile" then 
		    gameWorld[1][drawingOrder[I]]:drawProjectile()
	    --elseif drawAoE ...
		end
		--love.graphics.print( tostring(drawingOrder[I]), gameWorld[1][drawingOrder[I]].x1, (gameWorld[1][drawingOrder[I]].y1 + gameWorld[1][drawingOrder[I]].thickness/2 - gameWorld[1][drawingOrder[I]].z1 - gameWorld[1][drawingOrder[I]].height)/(proectionCoef)  )
		--below is debug
		if not gameWorld[1][drawingOrder[I]].physicless and gameState == "general game" then   
			--love.graphics.line( gameWorld[1][drawingOrder[I]].x1 + gameWorld[1][drawingOrder[I]].width / 2, (gameWorld[1][drawingOrder[I]].y1 + gameWorld[1][drawingOrder[I]].thickness/2 - gameWorld[1][drawingOrder[I]].z1 - gameWorld[1][drawingOrder[I]].height / 2)/(proectionCoef)  , gameWorld[1][drawingOrder[I]].x1 + gameWorld[1][drawingOrder[I]].width / 2 + gameWorld[1][drawingOrder[I]].debuggingdx, (gameWorld[1][drawingOrder[I]].y1 + gameWorld[1][drawingOrder[I]].thickness/2 + gameWorld[1][drawingOrder[I]].debuggingdy - gameWorld[1][drawingOrder[I]].z1 - gameWorld[1][drawingOrder[I]].height / 2 - gameWorld[1][drawingOrder[I]].debuggingdz)/(proectionCoef) )
		end
		I = I + 1
	end

	
	--love.graphics.rectangle("fill", gameWorld[1][1].x1, gameWorld[1][1].y1 / 2, 1, 1)
	love.graphics.translate( -intcamerax, -intcameray )
	if gameState == "conversation" and currentPhrase ~= nil then
	    love.graphics.setColor(0,0,0)
		--dialogue window
		love.graphics.rectangle( "fill", 0, 0, 800, 100 )
		love.graphics.setColor(25,25,25)
		--character window
		love.graphics.rectangle( "fill", 10, 10, 80, 80 )
		--text window
		love.graphics.rectangle( "fill", 100, 10, 690, 80 )
	    love.graphics.setColor(255,255,255)
		if currentPhrase.talker ~= nil then
		    if currentPhrase.talker.idle_front.currentImg.image ~= nil then
		        love.graphics.draw(currentPhrase.talker.idle_front.currentImg.image, 50 - currentPhrase.talker.idle_front.currentImg.image:getWidth()/2, 50 - currentPhrase.talker.idle_front.currentImg.image:getHeight()/2  )
		    end
		end
		if #currentPhrase <= 0 then
		    love.graphics.print(currentPhrase.text, 150, 20)
		elseif #currentPhrase > 0 then
		    love.graphics.print(currentPhrase.text, replyBounds[1], replyBounds[2] - 20)
		    love.graphics.setColor(0,0,0)
		    love.graphics.rectangle( "fill", replyBounds[1] - 20, 100, replyBounds.width + 40, math.max(0, #currentPhrase * replyBounds.gapY--[[20]] + replyBounds[2] - 80 + replyBounds.height) )
			love.graphics.setColor(25,25,25)
			love.graphics.rectangle( "fill", replyBounds[1] - 10, 90, replyBounds.width + 20, math.max(0, #currentPhrase * replyBounds.gapY + replyBounds[2] - 80 + replyBounds.height) )
			I = 1
			while I <= #currentPhrase do
			    love.graphics.setColor(51,51,51)
			    love.graphics.rectangle( "fill", replyBounds[1], replyBounds.gapY * (I - 1) + replyBounds[2], replyBounds.width--[[150]], replyBounds.height--[[15]] )
			    love.graphics.setColor(255,255,255)
				love.graphics.print(currentPhrase[I].text, replyBounds[1] + 2, replyBounds.gapY * (I - 1) + replyBounds[2] + 2)
			    I = I + 1
			end
		end
	end
	--[[if collidedBool == false then
	love.graphics.print( "collision = false", 10, 10 )
	    else
	love.graphics.print( "collision = true", 10, 10 )
	end
	love.graphics.print( "voronoix = "..tostring(voronoix),10,20 )
	love.graphics.print( "voronoiy = "..tostring(voronoiy),10,30 )
	love.graphics.print( "voronoiz = "..tostring(voronoiz),10,40 )
	love.graphics.print( "debugging = "..tostring(debugging),10,50 )
	--love.graphics.print( "surfaceTimer1 = "..tostring(gameWorld[1][1].surfaceTimer),10,60 )
	--love.graphics.print( "onSurface1 = "..tostring(gameWorld[1][1].onSurface),10,70 )
	--love.graphics.print( "jumped1 = "..tostring(gameWorld[1][1].jumped),10,80 )

	--love.graphics.print( "value = "..tostring(player_dash_trigger.value),10,60 )
	--love.graphics.print( "prevvalue = "..tostring(player_dash_trigger.prevvalue),10,70 )
	--love.graphics.print( "almost = "..tostring(player_dash_trigger.almost),10,80 )

	love.graphics.print( "x = "..tostring(gameWorld[1][1].x1),10,90 )
	love.graphics.print( "y = "..tostring(gameWorld[1][1].y1),10,100 )
	love.graphics.print( "z = "..tostring(gameWorld[1][1].z1),10,110 )
	--love.graphics.print( " t_needed = "..tostring(t_needed),10,120 )
	love.graphics.print( "playerdz = "..tostring(gameWorld[1][1].dz),10,130 )
	--love.graphics.print( "t1 = "..tostring(t1),10,140 )
	--love.graphics.print( "t2 = "..tostring(t2),10,150 )
	love.graphics.print( "debwog[1] = "..tostring(debwog[1]),10,160 )
	love.graphics.print( "debwog[2] = "..tostring(debwog[2]),10,170 )
	love.graphics.print( "debwog[3] = "..tostring(debwog[3]),10,180 )
	love.graphics.print( "debwog[4] = "..tostring(debwog[4]),10,190 )
	love.graphics.print( "framerate = "..tostring(framerate),10,200 )
	love.graphics.print( "getmetatable = "..tostring(getmetatable(gameWorld[1][1]) == Character),10,210 )
	--love.graphics.print( "mouse_actual_position[1] = "..tostring(mouse_actual_position[1]),10,220 )
	--love.graphics.print( "mouse_actual_position[2] = "..tostring(mouse_actual_position[2]),10,230 )
	--love.graphics.print( "mouse_actual_position[3] = "..tostring(mouse_actual_position[3]),10,240 )
	love.graphics.print( "lmb_pressed[1] = "..tostring(lmb_pressed[1]),10,250 )
	love.graphics.print( "lmb_pressed[2] = "..tostring(lmb_pressed[2]),10,260 )
	love.graphics.print( "lmb_pressed[3] = "..tostring(lmb_pressed[3]),10,270 )
	love.graphics.print( "global timer = "..tostring(timers.global),10,280 )
	love.graphics.print( "ring[3] = "..tostring(ring_of_spheres[3]),10,290 )
	love.graphics.print( "cosangle = "..tostring(cosangle),10,300 )
	love.graphics.print( "sinangle = "..tostring(sinangle),10,310 )
	love.graphics.print( "width = "..tostring(love.graphics.getWidth( )),10,320 )
	love.graphics.print( "height = "..tostring(love.graphics.getHeight( )),10,330 )
	love.graphics.print( "gameState = "..tostring(gameState),10,340 )--]]
	--love.graphics.setColor(0,0,0)
	
	if not events[12].caused and not events[9].caused and gameState ~= "conversation" then
	
	    love.graphics.setColor(0,0,0)
		love.graphics.rectangle( "fill", 280, 550, 580 - 280, 50 )
	    love.graphics.setColor(25,25,25)
	    love.graphics.rectangle( "fill", 290, 560, 570 - 290, 40 )
	    love.graphics.setColor(255,255,255)
	    love.graphics.print( "Necromancer HP = "..tostring(gameWorld[1][2].curHP),425,570 )
	    love.graphics.print( "Wizard HP = "..tostring(gameWorld[1][1].curHP),300,570 )
		
	end
	love.graphics.setColor(0,0,0)
	love.graphics.rectangle( "fill", 0, 570, 160, 30 )
	love.graphics.setColor(25,25,25)
	love.graphics.rectangle( "fill", 0, 580, 150, 20 )
	love.graphics.setColor(255,255,255)
	if events[12].caused then
	    love.graphics.print( "VICTORY", 370, 20 )
	elseif events[9].caused then
	    love.graphics.print( "DEFEAT", 375, 20 )
	end
	if tab_toggled then	
	    love.graphics.setColor(0,0,0,180)
		love.graphics.rectangle("fill", 0, 0, 800, 600 )
		love.graphics.setColor(255,255,255)
		love.graphics.print( "Programmer:Domenje", 330, 200 )
		love.graphics.print( "Artists:Sean Howard", 330, 400 )
		love.graphics.print( "Free Pixel Project", 330, 412 )
	    love.graphics.print( "http://www.squidi.net/pixel", 330, 424 )
        love.graphics.draw( license, 330, 439 )
    end
	
	love.graphics.print( "Press TAB for credits", 10, 585 )
	--love.graphics.translate( camerax, cameray )
end
function love.mousepressed(x, y, button)
    if button == 'l' then
	    --temporary measure
		--put keypressed here too
		--lmb once is falsed at the end of update
		lmb_pressed_once = {x, y, true}
		lmb_pressed = {x, y, true}
		--[[
	    if fireball_timer == 0 then
            gameWorld[1][1].action = {"fire", fireball, 0, math.rad(45), 1}
		    gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_front )
			fireball_timer = 1
		end
		--]]
    end
end
function love.mousereleased(x, y, button)
    if button == 'l' then
	    --temporary measure
		--put keypressed here too
		lmb_pressed = {x, y, false}
		--[[
	    if fireball_timer == 0 then
            gameWorld[1][1].action = {"fire", fireball, 0, math.rad(45), 1}
		    gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_front )
			fireball_timer = 1
		end
		--]]
    end
end
function love.keypressed(k)
    if k == "w" then
	    w_pressed = true
    elseif k == "a" then
	    a_pressed = true
	elseif k == "s" then
	    s_pressed = true
	elseif k == "d" then
	    d_pressed = true
	elseif k == "up" then
	    up_pressed = true
	elseif k == "left" then
	    left_pressed = true
	elseif k == "down" then
	    down_pressed = true
	elseif k == "right" then
	    right_pressed = true
	elseif k == " " then
	    space_pressed = true
	elseif k == "e" then
	    --e_toggled = not e_toggled ?
	    if e_toggled then
		    e_toggled = false
		else
		    e_toggled = true
		end
	elseif k == "return" then
	    return_pressed_once = true
	elseif k == "tab" then
	    tab_toggled = not tab_toggled
	end
end
function love.keyreleased(k)
--make animation_state changes in AI section
    if k == "w" then
	    w_pressed = false
		gameWorld[1][1].action = {"walk", 0, 0}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_back )
    elseif k == "a" then
	    a_pressed = false
		gameWorld[1][1].action = {"walk", 0, 0}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_left )
	elseif k == "s" then
	    s_pressed = false
		gameWorld[1][1].action = {"walk", 0, 0}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_front )
	elseif k == "d" then
	    d_pressed = false
		gameWorld[1][1].action = {"walk", 0, 0}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_right )
	elseif k == "up" then
	    up_pressed = false
	elseif k == "left" then
	    left_pressed = false
	elseif k == "down" then
	    down_pressed = false
	elseif k == "right" then
	    right_pressed = false
	elseif k == " " then
	    space_pressed = false
		gameWorld[1][1].action = {"walk", 0, 0}
		gameWorld[1][1]:changeCurrentAnim( gameWorld[1][1].idle_front )
	
	end
end
